//+---------------------------------------------------------------------+
//|                                                    T101 v3.4.mq4    |
//|                                  Copyright  2008, thomas liles.    |
//|                                       http://www.trendchaser.org    |
//|added code to sort pairs in descending order: guiomdetalle, 28/09/08 |
//|MrPip 10/7/08                                                        |
//|  added code for trading either IBFX sets or FXDD sets               |
//|  added code to trade 3 sessions and to not trade at end of week     |
//|  modified code for correct usage of Point                           |
//|  optimized code for speed in buy and sell functions                 | 
//+---------------------------------------------------------------------+
#property copyright "Copyright  2008, thomas liles."
#property link      "http://www.trendchaser.org"

extern bool alert= true;
extern bool can_trade= true;
extern bool equity_trail= true;
extern double start_trail= 0.5;
extern double trail= 0.5;
extern double starting_target=-100;
extern  bool exit_on_reverse= true;
extern double Lot= 0.01;
extern double Maximum_Risk = 0.5;

extern int tf=60;
extern int look_back= 5;
extern bool update_start= true;
extern double pips_filter= 100;
extern  bool reset_ea_zero_pips= true;
extern bool BrokerIsIBFX = true;
extern string Broker1 = "---IBFX Inputs---";
extern string ilong_basket= "enter 7 long symbols - no m";
extern string ilong_basket1= "GBPUSD";
extern double iprice1= 0;
extern string ilong_basket2= "EURGBP";
extern double iprice2= 0;
extern string ilong_basket3= "GBPJPY";
extern double iprice3= 0;
extern string ilong_basket4= "USDCHF";
extern double iprice4= 0;
extern string ilong_basket5= "NZDUSD";
extern double iprice5= 0;
extern string ilong_basket6= "AUDJPY";
extern double iprice6= 0;
extern string ilong_basket7= "EURJPY";
extern double iprice7= 0;

extern string ishort_basket= "enter 7 short symbols - no m";
extern string ishort_basket1= "EURUSD";
extern double iprice8= 0;
extern string ishort_basket2= "USDJPY";
extern double iprice9= 0;
extern string ishort_basket3= "AUDUSD";
extern double iprice10= 0;
extern string ishort_basket4= "NZDJPY";
extern double iprice11= 0;
extern string ishort_basket5= "GBPCHF";
extern double iprice12= 0;
extern string ishort_basket6= "CHFJPY";
extern double iprice13= 0;
extern string ishort_basket7= "EURCHF";
extern double iprice14= 0;

extern string Broker2 = "---FXDD Inputs---";
extern string flong_basket= "enter 7 long symbols";
extern string flong_basket1= "AUDJPY";
extern double fprice1= 0;
extern string flong_basket2= "CHFJPY";
extern double fprice2= 0;
extern string flong_basket3= "EURGBP";
extern double fprice3= 0;
extern string flong_basket4= "EURJPY";
extern double fprice4= 0;
extern string flong_basket5= "GBPCHF";
extern double fprice5= 0;
extern string flong_basket6= "GBPUSD";
extern double fprice6= 0;
extern string flong_basket7= "USDCHF";
extern double fprice7= 0;

extern string fshort_basket= "enter 7 short symbols";
extern string fshort_basket1= "AUDUSD";
extern double fprice8= 0;
extern string fshort_basket2= "CADJPY";
extern double fprice9= 0;
extern string fshort_basket3= "EURCHF";
extern double fprice10= 0;
extern string fshort_basket4= "EURUSD";
extern double fprice11= 0;
extern string fshort_basket5= "GBPJPY";
extern double fprice12= 0;
extern string fshort_basket6= "USDCAD";
extern double fprice13= 0;
extern string fshort_basket7= "USDJPY";
extern double fprice14= 0;

extern color BuySetColor = Green;
extern color SellSetColor = Red;

extern int profit_font_size =16;
extern int slippage =100;

bool time_restriction= false;

// Inputs for trading time filters
extern bool    UseFridayNoTradeTime = false;
extern int     FridayFinalHour = 20;   // No trades to start after time
extern string  sm0="--Trading Hours Filter--";
extern bool    UseTradingHours = false;
extern bool    TradeAsianMarket = true;
extern int     AsianStart = 100;       // Start trades after time
extern int     AsianStop = 400;      // Stop trading after time
extern bool    TradeEuropeanMarket = true;
extern int     EurStart = 1000;       // Start trades after time
extern int     EurStop = 1200;      // Stop trading after time
extern bool    TradeNewYorkMarket = true;
extern int     NYStart = 1600;       // Start trades after time
extern int     NYStop = 1800;      // Stop trading after time

 double interval=1;
 bool use_ma= false;
 int ma_tf =240;
 int ma_period =20;
bool trade_allowed=true;
double       minutes  = 0;
double pcnt,pcntd,interval2,target_dollars;
double ma1,ma2,ma3,ma4,ma5,ma6,ma7,ma8,ma9,ma10,ma11,ma12,ma13,ma14;
bool longs_allowed=true,long_alert=true;
bool shorts_allowed=true,short_alert=true;

/*
double GBPUSDm,EURGBPm,GBPJPYm,USDCHFm,NZDUSDm,AUDJPYm,EURJPYm;
double EURUSDm,USDJPYm,AUDUSDm,NZDJPYm,GBPCHFm,CHFJPYm,EURCHFm;

double GBPUSDm_now,EURGBPm_now,GBPJPYm_now,USDCHFm_now,NZDUSDm_now,AUDJPYm_now,EURJPYm_now;
double EURUSDm_now,USDJPYm_now,AUDUSDm_now,NZDJPYm_now,GBPCHFm_now,CHFJPYm_now,EURCHFm_now;

double GBPUSDm_pips,EURGBPm_pips,GBPJPYm_pips,USDCHFm_pips,NZDUSDm_pips,AUDJPYm_pips,EURJPYm_pips;
double EURUSDm_pips,USDJPYm_pips,AUDUSDm_pips,NZDJPYm_pips,GBPCHFm_pips,CHFJPYm_pips,EURCHFm_pips;

int gbpusd,eurgbp,gbpjpy,usdchf,nzdusd,audjpy,eurjpy;
int eurusd,usdjpy,audusd,nzdjpy,gbpchf,chfjpy,eurchf;
*/

// Modified to be able to trade any sets
double longPair1_m,longPair2_m,longPair3_m,longPair4_m,longPair5_m,longPair6_m,longPair7_m;
double shortPair1_m,shortPair2_m,shortPair3_m,shortPair4_m,shortPair5_m,shortPair6_m,shortPair7_m;

double longPair1_m_now,longPair2_m_now,longPair3_m_now,longPair4_m_now,longPair5_m_now,longPair6_m_now,longPair7_m_now;
double shortPair1_m_now,shortPair2_m_now,shortPair3_m_now,shortPair4_m_now,shortPair5_m_now,shortPair6_m_now,shortPair7_m_now;

double longPair1_m_pips,longPair2_m_pips,longPair3_m_pips,longPair4_m_pips,longPair5_m_pips,longPair6_m_pips,longPair7_m_pips;
double shortPair1_m_pips,shortPair2_m_pips,shortPair3_m_pips,shortPair4_m_pips,shortPair5_m_pips,shortPair6_m_pips,shortPair7_m_pips;

int longPair1_trades,longPair2_trades,longPair3_trades,longPair4_trades,longPair5_trades,longPair6_trades,longPair7_trades;
int shortPair1_trades,shortPair2_trades,shortPair3_trades,shortPair4_trades,shortPair5_trades,shortPair6_trades,shortPair7_trades;

double highest_long_pips=0, highest_short_pips=0,long_pips, short_pips;
string signal;

// Moved from within function
int spread1,spread2,spread3,spread4,spread5,spread6,spread7;
int spread8,spread9,spread10,spread11,spread12,spread13,spread14;

int blue,red,buys,sells;
bool close_l= false;
bool close_s= false;
bool close_all= false;
bool open_buys= false;
bool open_sells= false;
string stat= "waiting";

// Variables to allow using IBFX or FXDD sets
string long_basket1, long_basket2, long_basket3, long_basket4, long_basket5, long_basket6, long_basket7;
string short_basket1, short_basket2, short_basket3, short_basket4, short_basket5, short_basket6, short_basket7;
double price1, price2, price3, price4, price5, price6, price7;
double price8, price9, price10, price11, price12, price13, price14;
//+------------------------------------------------------------------+
//|     TC                                
//+------------------------------------------------------------------+

int init()
{
   GetCorrectPairs();
   GetSpreads();
orders();
checkup();
run_statistics_longs();  
run_statistics_shorts(); 
comments();
check_signal();
draw_objects();
return(0);
}

//+------------------------------------------------------------------+
//|     TC                                
//+------------------------------------------------------------------+

int deinit()
{
return(0);
}

//+------------------------------------------------------------------+
//|     TC                                
//+------------------------------------------------------------------+

int start()
{
orders();
if(open_buys&&sells==14)open_buys=false;
if(open_sells&&buys==14)open_sells=false;
if(close_l) {longs_allowed=false;close_longs();}
if(close_s) {shorts_allowed=false;close_shorts();}
if(close_all&&buys>0){longs_allowed=false; close();}
if(close_all&&sells>0){longs_allowed=false; close();}
if(update_start) checkup();
run_statistics_longs();  
run_statistics_shorts(); 
comments();
check_signal();
check_exit();
if(open_buys&&close_l==false&&close_s==false&&close_all==false&&open_sells==false) {stat="opening buys";buy();}
if(open_sells&&close_l==false&&close_s==false&&close_all==false&&open_buys==false) {stat="opening sells";sell();}
orders();
if(use_ma==false&&open_buys&&buys==14) open_buys=false;
if(use_ma==false&&open_sells&&sells==14) open_sells=false;
if(close_l&&buys==0) close_l=false;
if(close_s&&sells==0) close_s=false;
if(close_all&&buys==0&&sells==0) close_all=false;
orders();
draw_objects();
if(close_l==false&&close_s==false&&close_all==false&&open_buys==false&&open_sells==false) stat="waiting";
return(0);
}




//+------------------------------------------------------------------+
//|     TC                                
//+------------------------------------------------------------------+
void orders()
{

pcnt =( (AccountEquity()-AccountBalance()) / AccountBalance())*100;
pcntd =AccountEquity()-AccountBalance() ;
target_dollars =( (AccountBalance()/100) *starting_target);
 buys=0;sells=0;
 longPair1_trades=0;longPair2_trades=0;longPair3_trades=0;
 longPair4_trades=0;longPair5_trades=0;longPair6_trades=0;longPair7_trades=0;
 shortPair1_trades=0;shortPair2_trades=0;shortPair3_trades=0;
 shortPair4_trades=0;shortPair5_trades=0;shortPair6_trades=0;shortPair7_trades=0;
  int totalorders = OrdersTotal();
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
           if ( OrderType() == OP_SELL )  {sells=sells+1;}
           if ( OrderType() == OP_BUY )   {buys=buys+1;}
           if ( OrderSymbol() == long_basket1 )  {longPair1_trades++;}
           if ( OrderSymbol() == long_basket2 )  {longPair2_trades++;}
           if ( OrderSymbol() == long_basket3 )  {longPair3_trades++;}
           if ( OrderSymbol() == long_basket4 )  {longPair4_trades++;}
           if ( OrderSymbol() == long_basket5 )  {longPair5_trades++;}
           if ( OrderSymbol() == long_basket6 )  {longPair6_trades++;}
           if ( OrderSymbol() == long_basket7 )  {longPair7_trades++;}
           if ( OrderSymbol() == short_basket1 )  {shortPair1_trades++;}
           if ( OrderSymbol() == short_basket2 )  {shortPair2_trades++;}
           if ( OrderSymbol() == short_basket3 )  {shortPair3_trades++;}
           if ( OrderSymbol() == short_basket4 )  {shortPair4_trades++;}
           if ( OrderSymbol() == short_basket5 )  {shortPair5_trades++;}
           if ( OrderSymbol() == short_basket6 )  {shortPair6_trades++;}
           if ( OrderSymbol() == short_basket7 )  {shortPair7_trades++;}

}
return;
}
//+------------------------------------------------------------------+
//|     TC                                
//+------------------------------------------------------------------+
void checkup(){

if (price1==0)longPair1_m= iOpen(long_basket1, tf, look_back);else longPair1_m=price1;
if (price2==0)longPair2_m= iOpen(long_basket2, tf, look_back);else longPair2_m=price2;
if (price3==0)longPair3_m= iOpen(long_basket3, tf, look_back);else longPair3_m=price3;
if (price4==0)longPair4_m= iOpen(long_basket4, tf, look_back);else longPair4_m=price4;
if (price5==0)longPair5_m= iOpen(long_basket5, tf, look_back);else longPair5_m=price5;
if (price6==0)longPair6_m= iOpen(long_basket6, tf, look_back);else longPair6_m=price6;
if (price7==0)longPair7_m= iOpen(long_basket7, tf, look_back);else longPair7_m=price7;
if (price8==0)shortPair1_m= iOpen(short_basket1, tf, look_back);else shortPair1_m=price8;
if (price9==0)shortPair2_m= iOpen(short_basket2, tf, look_back);else shortPair2_m=price9;
if (price10==0)shortPair3_m= iOpen(short_basket3, tf, look_back);else shortPair3_m=price10;
if (price11==0)shortPair4_m= iOpen(short_basket4, tf, look_back);else shortPair4_m=price11;
if (price12==0)shortPair5_m= iOpen(short_basket5, tf, look_back);else shortPair5_m=price12;
if (price13==0)shortPair6_m= iOpen(short_basket6, tf, look_back);else shortPair6_m=price13;
if (price14==0)shortPair7_m= iOpen(short_basket7, tf, look_back);else shortPair7_m=price14;}
//+------------------------------------------------------------------+
//|     TC                                
//+------------------------------------------------------------------+
void run_statistics_longs()
{
longPair1_m_now= iClose(long_basket1, 0, 0);
longPair2_m_now= iClose(long_basket2, 0, 0);
longPair3_m_now= iClose(long_basket3, 0, 0);
longPair4_m_now= iClose(long_basket4, 0, 0);
longPair5_m_now= iClose(long_basket5, 0, 0);
longPair6_m_now= iClose(long_basket6, 0, 0);
longPair7_m_now= iClose(long_basket7, 0, 0);

longPair1_m_pips = (longPair1_m_now-longPair1_m)/dPoint(long_basket1)-spread1;
//longPair1_m_pips = longPair1_m_pips*MarketInfo(long_basket1,MODE_TICKVALUE);

longPair2_m_pips = (longPair2_m_now-longPair2_m)/dPoint(long_basket2)-spread2;
//longPair2_m_pips = longPair2_m_pips*MarketInfo(long_basket2,MODE_TICKVALUE);

longPair3_m_pips = (longPair3_m_now-longPair3_m)/dPoint(long_basket3)-spread3;
//longPair3_m_pips = longPair3_m_pips*MarketInfo(long_basket3,MODE_TICKVALUE);

longPair4_m_pips = (longPair4_m_now-longPair4_m)/dPoint(long_basket4)-spread4;
//longPair4_m_pips = longPair4_m_pips*MarketInfo(long_basket4,MODE_TICKVALUE);

longPair5_m_pips = (longPair5_m_now-longPair5_m)/dPoint(long_basket5)-spread5;
//longPair5_m_pips = longPair5_m_pips*MarketInfo(long_basket5,MODE_TICKVALUE);

longPair6_m_pips = (longPair6_m_now-longPair6_m)/dPoint(long_basket6)-spread6;
//longPair6_m_pips = longPair6_m_pips*MarketInfo(long_basket6,MODE_TICKVALUE);

longPair7_m_pips = (longPair7_m_now-longPair7_m)/dPoint(long_basket7)-spread7;
//longPair7_m_pips = longPair7_m_pips*MarketInfo(long_basket7,MODE_TICKVALUE);

long_pips = longPair1_m_pips + longPair2_m_pips + longPair3_m_pips + longPair4_m_pips + longPair5_m_pips + longPair6_m_pips + longPair7_m_pips;
if (long_pips>highest_long_pips) highest_long_pips=long_pips;
return;
}
//+------------------------------------------------------------------+
//|     TC                                
//+------------------------------------------------------------------+
void run_statistics_shorts()
{
shortPair1_m_now= iClose(short_basket1, 0, 0);
shortPair2_m_now= iClose(short_basket2, 0, 0);
shortPair3_m_now= iClose(short_basket3, 0, 0);
shortPair4_m_now= iClose(short_basket4, 0, 0);
shortPair5_m_now= iClose(short_basket5, 0, 0);
shortPair6_m_now= iClose(short_basket6, 0, 0);
shortPair7_m_now= iClose(short_basket7, 0, 0);

shortPair1_m_pips = (shortPair1_m-shortPair1_m_now)/dPoint(short_basket1)-spread8;
//shortPair1_m_pips = shortPair1_m_pips*MarketInfo(short_basket1,MODE_TICKVALUE);

shortPair2_m_pips = (shortPair2_m-shortPair2_m_now)/dPoint(short_basket2)-spread9;
//shortPair2_m_pips = shortPair2_m_pips*MarketInfo(short_basket2,MODE_TICKVALUE);

shortPair3_m_pips = (shortPair3_m-shortPair3_m_now)/dPoint(short_basket3)-spread10;
//shortPair3_m_pips = shortPair3_m_pips*MarketInfo(short_basket3,MODE_TICKVALUE);

shortPair4_m_pips = (shortPair4_m-shortPair4_m_now)/dPoint(short_basket4)-spread11;
//shortPair4_m_pips = shortPair4_m_pips*MarketInfo(short_basket4,MODE_TICKVALUE);

shortPair5_m_pips = (shortPair5_m-shortPair5_m_now)/dPoint(short_basket5)-spread12;
//shortPair5_m_pips = shortPair5_m_pips*MarketInfo(short_basket5,MODE_TICKVALUE);

shortPair6_m_pips = (shortPair6_m-shortPair6_m_now)/dPoint(short_basket6)-spread13;
//shortPair6_m_pips = shortPair6_m_pips*MarketInfo(short_basket6,MODE_TICKVALUE);

shortPair7_m_pips = (shortPair7_m-shortPair7_m_now)/dPoint(short_basket7)-spread14;
//shortPair7_m_pips = shortPair7_m_pips*MarketInfo(short_basket7,MODE_TICKVALUE);

short_pips = shortPair1_m_pips + shortPair2_m_pips + shortPair3_m_pips + shortPair4_m_pips + shortPair5_m_pips + shortPair6_m_pips + shortPair7_m_pips;
if (short_pips>highest_short_pips) highest_short_pips=short_pips;
return;
}

//+------------------------------------------------------------------+
//|     TC                                
//+------------------------------------------------------------------+
void check_signal(){
signal = "Ranging";
if (reset_ea_zero_pips&& long_pips<=0&&short_pips<=0 &&buys==0&&sells==0)  {longs_allowed=true;
shorts_allowed=true;}
if ( buys==14 )  {longs_allowed=false;}
if ( sells==14 )  {shorts_allowed=false;}
if ( buys==0&&sells==0 )  {starting_target=-100;}
interval2 = interval*60;
if (TimeCurrent()<minutes)  trade_allowed=false;
if (TimeCurrent()>minutes)  trade_allowed=true;
if (long_pips>pips_filter) {signal = "long";}
if (short_pips>pips_filter) {signal = "short";}
if (long_pips<0 ){highest_long_pips=0;}
if (short_pips<0){highest_short_pips=0;}
time_restriction = CheckTradeFilters();
if (time_restriction&&close_l==false&&close_s==false&&close_all==false&&open_buys==false&&open_sells==false&&longs_allowed&&trade_allowed&&can_trade&&signal=="long")
{
open_buys=true;

shorts_allowed=true;
}

if (time_restriction&&close_l==false&&close_s==false&&close_all==false&&open_buys==false&&open_sells==false&&shorts_allowed&&trade_allowed&&can_trade&&signal=="short")
{
open_sells=true;

longs_allowed=true;
}
}


//+------------------------------------------------------------------+
//|     TC                                
//+------------------------------------------------------------------+
void comments(){
double g;
int m,s,k,h;
m=Time[0]+Period()*60-TimeCurrent();
g=m/60.0;
s=m%60;
m=(m-m%60)/60;
if(m>=60) h=m/60; else h=0;
k=m-(h*60);
datetime m1=Time[0]+Period()*60-TimeCurrent();
datetime m5=Time[0]+5*60-TimeCurrent();
datetime m15=Time[0]+15*60-TimeCurrent();
datetime m30=Time[0]+30*60-TimeCurrent();
datetime m60=Time[0]+60*60-TimeCurrent();
datetime m240=Time[0]+240*60-TimeCurrent();
Comment("\n","bar timer= ",TimeToStr(m1,TIME_SECONDS),
"\n","buys= ",buys,
"     sells= ",sells);  
}


//+------------------------------------------------------------------+
//|     TC                                
//+------------------------------------------------------------------+
double LotsOptimized()
{
double minimum_lots=MarketInfo(Symbol(),MODE_MINLOT);
double max_lots=MarketInfo(Symbol(),MODE_MAXLOT);
double lot=Lot;   

     if (minimum_lots==0.001){ lot=NormalizeDouble(AccountBalance()*Maximum_Risk/1000,3);{}}
     if (minimum_lots==0.01){ lot=NormalizeDouble(AccountBalance()*Maximum_Risk/10000,2);{}}
     if (minimum_lots==0.1){ lot=NormalizeDouble(AccountBalance()*Maximum_Risk/100000,1); {}}  
     if (minimum_lots==1){ lot=NormalizeDouble(AccountBalance()*Maximum_Risk/1000000,0);{}}
     
     if (lot<=minimum_lots){lot  = minimum_lots;{}}
     if (lot>=max_lots){lot  = max_lots;{}}
     if (lot<=Lot){lot  = Lot;{}}      // prevent lots from decreasing
     if (Maximum_Risk==0){lot  = Lot;{}}
return(lot);
}


void GetMAs()
{
  ma1=iMA(long_basket1,ma_tf,ma_period,0,MODE_SMA,PRICE_CLOSE,0);
  ma2=iMA(long_basket2,ma_tf,ma_period,0,MODE_SMA,PRICE_CLOSE,0);
  ma3=iMA(long_basket3,ma_tf,ma_period,0,MODE_SMA,PRICE_CLOSE,0);
  ma4=iMA(long_basket4,ma_tf,ma_period,0,MODE_SMA,PRICE_CLOSE,0);
  ma5=iMA(long_basket5,ma_tf,ma_period,0,MODE_SMA,PRICE_CLOSE,0);
  ma6=iMA(long_basket6,ma_tf,ma_period,0,MODE_SMA,PRICE_CLOSE,0);
  ma7=iMA(long_basket7,ma_tf,ma_period,0,MODE_SMA,PRICE_CLOSE,0);
  ma8=iMA(short_basket1,ma_tf,ma_period,0,MODE_SMA,PRICE_CLOSE,0);
  ma9=iMA(short_basket2,ma_tf,ma_period,0,MODE_SMA,PRICE_CLOSE,0);
  ma10=iMA(short_basket3,ma_tf,ma_period,0,MODE_SMA,PRICE_CLOSE,0);
  ma11=iMA(short_basket4,ma_tf,ma_period,0,MODE_SMA,PRICE_CLOSE,0);
  ma12=iMA(short_basket5,ma_tf,ma_period,0,MODE_SMA,PRICE_CLOSE,0);
  ma13=iMA(short_basket6,ma_tf,ma_period,0,MODE_SMA,PRICE_CLOSE,0);
  ma14=iMA(short_basket7,ma_tf,ma_period,0,MODE_SMA,PRICE_CLOSE,0);
}

//+------------------------------------------------------------------+
//|     TC                                
//+------------------------------------------------------------------+
void buy()
{
 double mLots;
close_l=false;close_s=false;close_all=false;
ObjectSetText("status","status = opening buys", profit_font_size,"Times New Roman",Red);

if (use_ma) GetMAs();

 mLots = LotsOptimized();
 if (use_ma)
{
  if (longs_allowed)
  {
    if (longPair1_m_now>ma1&&longPair1_trades==0)OrderSend(long_basket1,OP_BUY, mLots, MarketInfo(long_basket1,MODE_ASK), slippage, 0, 0, NULL, 0, 0, Blue);
    if (longPair2_m_now>ma2&&longPair2_trades==0)OrderSend(long_basket2,OP_BUY, mLots, MarketInfo(long_basket2,MODE_ASK), slippage, 0, 0, NULL, 0, 0, Blue);
    if (longPair3_m_now>ma3&&longPair3_trades==0)OrderSend(long_basket3,OP_BUY, mLots, MarketInfo(long_basket3,MODE_ASK), slippage, 0, 0, NULL, 0, 0, Blue);
    if (longPair4_m_now>ma4&&longPair4_trades==0)OrderSend(long_basket4,OP_BUY, mLots, MarketInfo(long_basket4,MODE_ASK), slippage, 0, 0, NULL, 0, 0, Blue);
    if (longPair5_m_now>ma5&&longPair5_trades==0)OrderSend(long_basket5,OP_BUY, mLots, MarketInfo(long_basket5,MODE_ASK), slippage, 0, 0, NULL, 0, 0, Blue);
    if (longPair6_m_now>ma6&&longPair6_trades==0)OrderSend(long_basket6,OP_BUY, mLots, MarketInfo(long_basket6,MODE_ASK), slippage, 0, 0, NULL, 0, 0, Blue);
    if (longPair7_m_now>ma7&&longPair7_trades==0)OrderSend(long_basket7,OP_BUY, mLots, MarketInfo(long_basket7,MODE_ASK), slippage, 0, 0, NULL, 0, 0, Blue);

    if (shortPair1_m_now>ma8&&shortPair1_trades==0)OrderSend(short_basket1,OP_BUY, mLots, MarketInfo(short_basket1,MODE_ASK), slippage, 0, 0, NULL, 0, 0, Blue);
    if (shortPair2_m_now>ma9&&shortPair2_trades==0)OrderSend(short_basket2,OP_BUY, mLots, MarketInfo(short_basket2,MODE_ASK), slippage, 0, 0, NULL, 0, 0, Blue);
    if (shortPair3_m_now>ma10&&shortPair3_trades==0)OrderSend(short_basket3,OP_BUY, mLots, MarketInfo(short_basket3,MODE_ASK), slippage, 0, 0, NULL, 0, 0, Blue);
    if (shortPair4_m_now>ma11&&shortPair4_trades==0)OrderSend(short_basket4,OP_BUY, mLots, MarketInfo(short_basket4,MODE_ASK), slippage, 0, 0, NULL, 0, 0, Blue);
    if (shortPair5_m_now>ma12&&shortPair5_trades==0)OrderSend(short_basket5,OP_BUY, mLots, MarketInfo(short_basket5,MODE_ASK), slippage, 0, 0, NULL, 0, 0, Blue);
    if (shortPair6_m_now>ma13&&shortPair6_trades==0)OrderSend(short_basket6,OP_BUY, mLots, MarketInfo(short_basket6,MODE_ASK), slippage, 0, 0, NULL, 0, 0, Blue);
    if (shortPair7_m_now>ma14&&shortPair7_trades==0)OrderSend(short_basket7,OP_BUY, mLots, MarketInfo(short_basket7,MODE_ASK), slippage, 0, 0, NULL, 0, 0, Blue);
  }
}
else
{
  if (longs_allowed)
  {
    if (longPair1_trades==0)OrderSend(long_basket1,OP_BUY, mLots, MarketInfo(long_basket1,MODE_ASK), slippage, 0, 0, NULL, 0, 0, Blue);
    if (longPair2_trades==0)OrderSend(long_basket2,OP_BUY, mLots, MarketInfo(long_basket2,MODE_ASK), slippage, 0, 0, NULL, 0, 0, Blue);
    if (longPair3_trades==0)OrderSend(long_basket3,OP_BUY, mLots, MarketInfo(long_basket3,MODE_ASK), slippage, 0, 0, NULL, 0, 0, Blue);
    if (longPair4_trades==0)OrderSend(long_basket4,OP_BUY, mLots, MarketInfo(long_basket4,MODE_ASK), slippage, 0, 0, NULL, 0, 0, Blue);
    if (longPair5_trades==0)OrderSend(long_basket5,OP_BUY, mLots, MarketInfo(long_basket5,MODE_ASK), slippage, 0, 0, NULL, 0, 0, Blue);
    if (longPair6_trades==0)OrderSend(long_basket6,OP_BUY, mLots, MarketInfo(long_basket6,MODE_ASK), slippage, 0, 0, NULL, 0, 0, Blue);
    if (longPair7_trades==0)OrderSend(long_basket7,OP_BUY, mLots, MarketInfo(long_basket7,MODE_ASK), slippage, 0, 0, NULL, 0, 0, Blue);

    if (shortPair1_trades==0)OrderSend(short_basket1,OP_BUY, mLots, MarketInfo(short_basket1,MODE_ASK), slippage, 0, 0, NULL, 0, 0, Blue);
    if (shortPair2_trades==0)OrderSend(short_basket2,OP_BUY, mLots, MarketInfo(short_basket2,MODE_ASK), slippage, 0, 0, NULL, 0, 0, Blue);  
    if (shortPair3_trades==0)OrderSend(short_basket3,OP_BUY, mLots, MarketInfo(short_basket3,MODE_ASK), slippage, 0, 0, NULL, 0, 0, Blue);
    if (shortPair4_trades==0)OrderSend(short_basket4,OP_BUY, mLots, MarketInfo(short_basket4,MODE_ASK), slippage, 0, 0, NULL, 0, 0, Blue);
    if (shortPair5_trades==0)OrderSend(short_basket5,OP_BUY, mLots, MarketInfo(short_basket5,MODE_ASK), slippage, 0, 0, NULL, 0, 0, Blue);
    if (shortPair6_trades==0)OrderSend(short_basket6,OP_BUY, mLots, MarketInfo(short_basket6,MODE_ASK), slippage, 0, 0, NULL, 0, 0, Blue);
    if (shortPair7_trades==0)OrderSend(short_basket7,OP_BUY, mLots, MarketInfo(short_basket7,MODE_ASK), slippage, 0, 0, NULL, 0, 0, Blue);
  }
}

orders();

if (use_ma==false&&buys==14){
longs_allowed=false;open_buys=false;open_sells=false;}
//orders();
return;
}
//+------------------------------------------------------------------+
//|     TC                                
//+------------------------------------------------------------------+
void sell()
{
 double mLots;
close_l=false;close_s=false;close_all=false;
ObjectSetText("status","status = opening sells", profit_font_size,"Times New Roman",Red);

if (use_ma) GetMAs();

 mLots = LotsOptimized();

if (use_ma)
{
  if (shorts_allowed)
  {
    if (longPair1_m_now<ma1&&longPair1_trades==0)OrderSend(long_basket1,OP_SELL, mLots, MarketInfo(long_basket1,MODE_BID), slippage, 0, 0, NULL, 0, 0, Red);
    if (longPair2_m_now<ma2&&longPair2_trades==0)OrderSend(long_basket2,OP_SELL, mLots, MarketInfo(long_basket2,MODE_BID), slippage, 0, 0, NULL, 0, 0, Red);
    if (longPair3_m_now<ma3&&longPair3_trades==0)OrderSend(long_basket3,OP_SELL, mLots, MarketInfo(long_basket3,MODE_BID), slippage, 0, 0, NULL, 0, 0, Red);
    if (longPair4_m_now<ma4&&longPair4_trades==0)OrderSend(long_basket4,OP_SELL, mLots, MarketInfo(long_basket4,MODE_BID), slippage, 0, 0, NULL, 0, 0, Red);
    if (longPair5_m_now<ma5&&longPair5_trades==0)OrderSend(long_basket5,OP_SELL, mLots, MarketInfo(long_basket5,MODE_BID), slippage, 0, 0, NULL, 0, 0, Red);
    if (longPair6_m_now<ma6&&longPair6_trades==0)OrderSend(long_basket6,OP_SELL, mLots, MarketInfo(long_basket6,MODE_BID), slippage, 0, 0, NULL, 0, 0, Red);
    if (longPair7_m_now<ma7&&longPair7_trades==0)OrderSend(long_basket7,OP_SELL, mLots, MarketInfo(long_basket7,MODE_BID), slippage, 0, 0, NULL, 0, 0, Red);

    if (shortPair1_m_now<ma8&&shortPair1_trades==0)OrderSend(short_basket1,OP_SELL, mLots, MarketInfo(short_basket1,MODE_BID), slippage, 0, 0, NULL, 0, 0, Red);
    if (shortPair2_m_now<ma9&&shortPair2_trades==0)OrderSend(short_basket2,OP_SELL, mLots, MarketInfo(short_basket2,MODE_BID), slippage, 0, 0, NULL, 0, 0, Red);
    if (shortPair3_m_now<ma10&&shortPair3_trades==0)OrderSend(short_basket3,OP_SELL, mLots, MarketInfo(short_basket3,MODE_BID), slippage, 0, 0, NULL, 0, 0, Red);
    if (shortPair4_m_now<ma11&&shortPair4_trades==0)OrderSend(short_basket4,OP_SELL, mLots, MarketInfo(short_basket4,MODE_BID), slippage, 0, 0, NULL, 0, 0, Red);
    if (shortPair5_m_now<ma12&&shortPair5_trades==0)OrderSend(short_basket5,OP_SELL, mLots, MarketInfo(short_basket5,MODE_BID), slippage, 0, 0, NULL, 0, 0, Red);
    if (shortPair6_m_now<ma13&&shortPair6_trades==0)OrderSend(short_basket6,OP_SELL, mLots, MarketInfo(short_basket6,MODE_BID), slippage, 0, 0, NULL, 0, 0, Red);
    if (shortPair7_m_now<ma14&&shortPair7_trades==0)OrderSend(short_basket7,OP_SELL, mLots, MarketInfo(short_basket7,MODE_BID), slippage, 0, 0, NULL, 0, 0, Red);
  }
}
else
{
  if (shorts_allowed)
  {
    if (longPair1_trades==0)OrderSend(long_basket1,OP_SELL, mLots, MarketInfo(long_basket1,MODE_BID), slippage, 0, 0, NULL, 0, 0, Red);
    if (longPair2_trades==0)OrderSend(long_basket2,OP_SELL, mLots, MarketInfo(long_basket2,MODE_BID), slippage, 0, 0, NULL, 0, 0, Red);
    if (longPair3_trades==0)OrderSend(long_basket3,OP_SELL, mLots, MarketInfo(long_basket3,MODE_BID), slippage, 0, 0, NULL, 0, 0, Red);
    if (longPair4_trades==0)OrderSend(long_basket4,OP_SELL, mLots, MarketInfo(long_basket4,MODE_BID), slippage, 0, 0, NULL, 0, 0, Red);
    if (longPair5_trades==0)OrderSend(long_basket5,OP_SELL, mLots, MarketInfo(long_basket5,MODE_BID), slippage, 0, 0, NULL, 0, 0, Red);
    if (longPair6_trades==0)OrderSend(long_basket6,OP_SELL, mLots, MarketInfo(long_basket6,MODE_BID), slippage, 0, 0, NULL, 0, 0, Red);
    if (longPair7_trades==0)OrderSend(long_basket7,OP_SELL, mLots, MarketInfo(long_basket7,MODE_BID), slippage, 0, 0, NULL, 0, 0, Red);

    if (shortPair1_trades==0)OrderSend(short_basket1,OP_SELL, mLots, MarketInfo(short_basket1,MODE_BID), slippage, 0, 0, NULL, 0, 0, Red);
    if (shortPair2_trades==0)OrderSend(short_basket2,OP_SELL, mLots, MarketInfo(short_basket2,MODE_BID), slippage, 0, 0, NULL, 0, 0, Red);
    if (shortPair3_trades==0)OrderSend(short_basket3,OP_SELL, mLots, MarketInfo(short_basket3,MODE_BID), slippage, 0, 0, NULL, 0, 0, Red);
    if (shortPair4_trades==0)OrderSend(short_basket4,OP_SELL, mLots, MarketInfo(short_basket4,MODE_BID), slippage, 0, 0, NULL, 0, 0, Red);
    if (shortPair5_trades==0)OrderSend(short_basket5,OP_SELL, mLots, MarketInfo(short_basket5,MODE_BID), slippage, 0, 0, NULL, 0, 0, Red);
    if (shortPair6_trades==0)OrderSend(short_basket6,OP_SELL, mLots, MarketInfo(short_basket6,MODE_BID), slippage, 0, 0, NULL, 0, 0, Red);
    if (shortPair7_trades==0)OrderSend(short_basket7,OP_SELL, mLots, MarketInfo(short_basket7,MODE_BID), slippage, 0, 0, NULL, 0, 0, Red);
  }
}

orders();
if (use_ma==false&&sells==14){
shorts_allowed=false;
open_sells=false;open_buys=false;}
//orders();
return;
}


//+------------------------------------------------------------------+
//|     TC                                
//+------------------------------------------------------------------+
void check_exit()
{
int totalorders = OrdersTotal();
for(int i=totalorders-1;i>=0;i--)
{
OrderSelect(i, SELECT_BY_POS);
{
if (equity_trail&&pcnt>=start_trail&&starting_target<pcnt-trail ){starting_target=pcnt-trail;}

if (pcnt<=starting_target ) 
{close_all=true;}
           
if (exit_on_reverse&&signal== "short" ) 
{close_l=true;shorts_allowed=true;}
           
if (exit_on_reverse&&signal== "long") 
{close_s=true;longs_allowed=true;}
}
}
return;
}


//+------------------------------------------------------------------+
//|     TC                                
//+------------------------------------------------------------------+
void draw_objects()
{
int companion =WindowFind("trendchaser_companion");
if (companion == -1)companion=0;
   blue=0;red=0;                                                                                  
   string PairsDisplay[14];   
   color  PairsColor[14];              
   double PLArray[14];
   PLArray[0]=longPair1_m_pips;PLArray[1]=longPair2_m_pips;PLArray[2]=shortPair5_m_pips;PLArray[3]=shortPair6_m_pips;PLArray[4]=longPair6_m_pips;PLArray[5]=longPair7_m_pips;
   PLArray[6]=longPair4_m_pips;PLArray[7]=shortPair4_m_pips;PLArray[8]=shortPair3_m_pips;PLArray[9]=shortPair2_m_pips;PLArray[10]=shortPair1_m_pips;
   PLArray[11]=shortPair7_m_pips;PLArray[12]=longPair3_m_pips;PLArray[13]=longPair5_m_pips;
   ArraySort(PLArray,WHOLE_ARRAY,0,MODE_DESCEND);
   
   for(int i=0;i<=13;i++)
    { 
      if(longPair1_m_pips==PLArray[i]) 
       {
         PairsDisplay[i] = ""+long_basket1+"";
         PairsColor[i] = BuySetColor; 
         if (longPair1_m_pips>0)     blue++;
        
       }
      if(longPair2_m_pips==PLArray[i]) 
       {
         PairsDisplay[i] = ""+long_basket2+"";
         PairsColor[i] = BuySetColor;  
         if (longPair2_m_pips>0)     blue++;
         
       }
      if(longPair3_m_pips==PLArray[i]) 
       {
         PairsDisplay[i] = ""+long_basket3+""; 
         PairsColor[i] = BuySetColor; 
         if (longPair3_m_pips>0)     blue++;
         
       }
      if(longPair4_m_pips==PLArray[i]) 
       {
         PairsDisplay[i] = ""+long_basket4+""; 
         PairsColor[i] = BuySetColor; 
         if (longPair4_m_pips>0)     blue++;
         
       }
      if(longPair5_m_pips==PLArray[i]) 
       {
         PairsDisplay[i] = ""+long_basket5+""; 
         PairsColor[i] = BuySetColor; 
         if (longPair5_m_pips>0)     blue++;
         
       }
      if(longPair6_m_pips==PLArray[i]) 
       {
         PairsDisplay[i] = ""+long_basket6+"";
         PairsColor[i] = BuySetColor; 
         if (longPair6_m_pips>0)     blue++;
        
       }
      if(longPair7_m_pips==PLArray[i]) 
       {
         PairsDisplay[i] = ""+long_basket7+""; 
         PairsColor[i] = BuySetColor; 
         if (longPair7_m_pips>0)     blue++;
        
       }
      if(shortPair1_m_pips==PLArray[i]) 
       {
         PairsDisplay[i] = ""+short_basket1+"";
         PairsColor[i] = SellSetColor; 
         if (shortPair1_m_pips>0)     red++;
         
       }
      if(shortPair2_m_pips==PLArray[i]) 
       {
         PairsDisplay[i] = ""+short_basket2+""; 
         PairsColor[i] = SellSetColor;
         if (shortPair2_m_pips>0)     red++;
        
       }
      if(shortPair3_m_pips==PLArray[i]) 
       {
         PairsDisplay[i] = ""+short_basket3+""; 
         PairsColor[i] = SellSetColor;
         if (shortPair3_m_pips>0)     red++;
         
       }
      if(shortPair4_m_pips==PLArray[i]) 
       {
         PairsDisplay[i] = ""+short_basket4+""; 
         PairsColor[i] = SellSetColor; 
         if (shortPair4_m_pips>0)     red++;
         
       }
      if(shortPair5_m_pips==PLArray[i]) 
       {
         PairsDisplay[i] = ""+short_basket5+""; 
         PairsColor[i] = SellSetColor; 
         if (shortPair5_m_pips>0)     red++;
         
       }
      if(shortPair6_m_pips==PLArray[i]) 
       {
         PairsDisplay[i] = ""+short_basket6+"";
         PairsColor[i] = SellSetColor;  
         if (shortPair6_m_pips>0)     red++;
         
       }
      if(shortPair7_m_pips==PLArray[i]) 
       {
         PairsDisplay[i] = ""+short_basket7+""; 
         PairsColor[i] = SellSetColor; 
         if (shortPair7_m_pips>0)     red++;
         
       }
     // Print(PairsDisplay[i],"...",i,"..",PairsColor[i]);
    }

if (ObjectFind("1") == -1 ){
ObjectCreate("1", OBJ_LABEL, companion, 0, 0);
ObjectSet("1", OBJPROP_COLOR, Red);
ObjectSet("1", OBJPROP_XDISTANCE, 10);
ObjectSet("1", OBJPROP_YDISTANCE, 40);}
if (PLArray[0]>0){ObjectSetText("1",PairsDisplay[0]+" =  "+DoubleToStr(PLArray[0],0), 10,"Times New Roman",PairsColor[0]);}
if (PLArray[0]<0){ObjectSetText("1",PairsDisplay[0]+" =  "+DoubleToStr(PLArray[0],0), 10,"Times New Roman",PairsColor[0]);}

if (ObjectFind("2") == -1 ){
ObjectCreate("2", OBJ_LABEL, companion, 0, 0);
ObjectSet("2", OBJPROP_COLOR, Red);
ObjectSet("2", OBJPROP_XDISTANCE, 10);
ObjectSet("2", OBJPROP_YDISTANCE, 60);}
if (PLArray[1]>0){ObjectSetText("2",PairsDisplay[1]+" =  "+DoubleToStr(PLArray[1],0), 10,"Times New Roman",PairsColor[1]);}
if (PLArray[1]<0){ObjectSetText("2",PairsDisplay[1]+" =  "+DoubleToStr(PLArray[1],0), 10,"Times New Roman",PairsColor[1]);}

if (ObjectFind("3") == -1 ){
ObjectCreate("3", OBJ_LABEL, companion, 0, 0);
ObjectSet("3", OBJPROP_COLOR, Red);
ObjectSet("3", OBJPROP_XDISTANCE, 10);
ObjectSet("3", OBJPROP_YDISTANCE, 80);}
if (PLArray[2]>0){ObjectSetText("3",PairsDisplay[2]+" =  "+DoubleToStr(PLArray[2],0), 10,"Times New Roman",PairsColor[2]);}
if (PLArray[2]<0){ObjectSetText("3",PairsDisplay[2]+" =  "+DoubleToStr(PLArray[2],0), 10,"Times New Roman",PairsColor[2]);}

if (ObjectFind("4") == -1 ){
ObjectCreate("4", OBJ_LABEL, companion, 0, 0);
ObjectSet("4", OBJPROP_COLOR, Red);
ObjectSet("4", OBJPROP_XDISTANCE, 10);
ObjectSet("4", OBJPROP_YDISTANCE, 100);}
if (PLArray[3]>0){ObjectSetText("4",PairsDisplay[3]+" =  "+DoubleToStr(PLArray[3],0), 10,"Times New Roman",PairsColor[3]);}
if (PLArray[3]<0){ObjectSetText("4",PairsDisplay[3]+" =  "+DoubleToStr(PLArray[3],0), 10,"Times New Roman",PairsColor[3]);}

if (ObjectFind("5") == -1 ){
ObjectCreate("5", OBJ_LABEL, companion, 0, 0);
ObjectSet("5", OBJPROP_COLOR, Red);
ObjectSet("5", OBJPROP_XDISTANCE, 10);
ObjectSet("5", OBJPROP_YDISTANCE, 120);}
if (PLArray[4]>0){ObjectSetText("5",PairsDisplay[4]+" =  "+DoubleToStr(PLArray[4],0), 10,"Times New Roman",PairsColor[4]);}
if (PLArray[4]<0){ObjectSetText("5",PairsDisplay[4]+" =  "+DoubleToStr(PLArray[4],0), 10,"Times New Roman",PairsColor[4]);}

if (ObjectFind("6") == -1 ){
ObjectCreate("6", OBJ_LABEL, companion, 0, 0);
ObjectSet("6", OBJPROP_COLOR, Red);
ObjectSet("6", OBJPROP_XDISTANCE, 10);
ObjectSet("6", OBJPROP_YDISTANCE, 140);}
if (PLArray[5]>0){ObjectSetText("6",PairsDisplay[5]+" =  "+DoubleToStr(PLArray[5],0), 10,"Times New Roman",PairsColor[5]);}
if (PLArray[5]<0){ObjectSetText("6",PairsDisplay[5]+" =  "+DoubleToStr(PLArray[5],0), 10,"Times New Roman",PairsColor[5]);}

if (ObjectFind("7") == -1 ){
ObjectCreate("7", OBJ_LABEL, companion, 0, 0);
ObjectSet("7", OBJPROP_COLOR, Red);
ObjectSet("7", OBJPROP_XDISTANCE, 10);
ObjectSet("7", OBJPROP_YDISTANCE, 160);}
if (PLArray[6]>0){ObjectSetText("7",PairsDisplay[6]+" =  "+DoubleToStr(PLArray[6],0), 10,"Times New Roman",PairsColor[6]);}
if (PLArray[6]<0){ObjectSetText("7",PairsDisplay[6]+" =  "+DoubleToStr(PLArray[6],0), 10,"Times New Roman",PairsColor[6]);}

if (ObjectFind("8") == -1 ){
ObjectCreate("8", OBJ_LABEL, companion, 0, 0);
ObjectSet("8", OBJPROP_COLOR, Red);
ObjectSet("8", OBJPROP_XDISTANCE, 10);
ObjectSet("8", OBJPROP_YDISTANCE, 200);}
if (PLArray[7]>0){ObjectSetText("8",PairsDisplay[7]+" =  "+DoubleToStr(PLArray[7],0), 10,"Times New Roman",PairsColor[7]);}
if (PLArray[7]<0){ObjectSetText("8",PairsDisplay[7]+" =  "+DoubleToStr(PLArray[7],0), 10,"Times New Roman",PairsColor[7]);}

if (ObjectFind("9") == -1 ){
ObjectCreate("9", OBJ_LABEL, companion, 0, 0);
ObjectSet("9", OBJPROP_COLOR, Red);
ObjectSet("9", OBJPROP_XDISTANCE, 10);
ObjectSet("9", OBJPROP_YDISTANCE, 220);}
if (PLArray[8]>0){ObjectSetText("9",PairsDisplay[8]+" =  "+DoubleToStr(PLArray[8],0), 10,"Times New Roman",PairsColor[8]);}
if (PLArray[8]<0){ObjectSetText("9",PairsDisplay[8]+" =  "+DoubleToStr(PLArray[8],0), 10,"Times New Roman",PairsColor[8]);}

if (ObjectFind("10") == -1 ){
ObjectCreate("10", OBJ_LABEL, companion, 0, 0);
ObjectSet("10", OBJPROP_COLOR, Red);
ObjectSet("10", OBJPROP_XDISTANCE, 10);
ObjectSet("10", OBJPROP_YDISTANCE, 240);}
if (PLArray[9]>0){ObjectSetText("10",PairsDisplay[9]+" =  "+DoubleToStr(PLArray[9],0), 10,"Times New Roman",PairsColor[9]);}
if (PLArray[9]<0){ObjectSetText("10",PairsDisplay[9]+" =  "+DoubleToStr(PLArray[9],0), 10,"Times New Roman",PairsColor[9]);}

if (ObjectFind("11") == -1 ){
ObjectCreate("11", OBJ_LABEL, companion, 0, 0);
ObjectSet("11", OBJPROP_COLOR, Red);
ObjectSet("11", OBJPROP_XDISTANCE, 10);
ObjectSet("11", OBJPROP_YDISTANCE, 260);}
if (PLArray[10]>0){ObjectSetText("11",PairsDisplay[10]+" =  "+DoubleToStr(PLArray[10],0), 10,"Times New Roman",PairsColor[10]);}
if (PLArray[10]<0){ObjectSetText("11",PairsDisplay[10]+" =  "+DoubleToStr(PLArray[10],0), 10,"Times New Roman",PairsColor[10]);}

if (ObjectFind("12") == -1 ){
ObjectCreate("12", OBJ_LABEL, companion, 0, 0);
ObjectSet("12", OBJPROP_COLOR, Red);
ObjectSet("12", OBJPROP_XDISTANCE, 10);
ObjectSet("12", OBJPROP_YDISTANCE, 280);}
if (PLArray[11]>0){ObjectSetText("12",PairsDisplay[11]+" =  "+DoubleToStr(PLArray[11],0), 10,"Times New Roman",PairsColor[11]);}
if (PLArray[11]<0){ObjectSetText("12",PairsDisplay[11]+" =  "+DoubleToStr(PLArray[11],0), 10,"Times New Roman",PairsColor[11]);}

if (ObjectFind("13") == -1 ){
ObjectCreate("13", OBJ_LABEL, companion, 0, 0);
ObjectSet("13", OBJPROP_COLOR, Red);
ObjectSet("13", OBJPROP_XDISTANCE, 10);
ObjectSet("13", OBJPROP_YDISTANCE, 300);}
if (PLArray[12]>0){ObjectSetText("13",PairsDisplay[12]+" =  "+DoubleToStr(PLArray[12],0), 10,"Times New Roman",PairsColor[12]);}
if (PLArray[12]<0){ObjectSetText("13",PairsDisplay[12]+" =  "+DoubleToStr(PLArray[12],0), 10,"Times New Roman",PairsColor[12]);}

if (ObjectFind("14") == -1 ){
ObjectCreate("14", OBJ_LABEL, companion, 0, 0);
ObjectSet("14", OBJPROP_COLOR, Red);
ObjectSet("14", OBJPROP_XDISTANCE, 10);
ObjectSet("14", OBJPROP_YDISTANCE, 320);}
if (PLArray[13]>0){ObjectSetText("14",PairsDisplay[13]+" =  "+DoubleToStr(PLArray[13],0), 10,"Times New Roman",PairsColor[13]);}
if (PLArray[13]<0){ObjectSetText("14",PairsDisplay[13]+" =  "+DoubleToStr(PLArray[13],0), 10,"Times New Roman",PairsColor[13]);}

if (ObjectFind("sig") == -1 ){
ObjectCreate("sig", OBJ_LABEL, companion, 0, 0);
ObjectSet("sig", OBJPROP_COLOR, Red);
ObjectSet("sig", OBJPROP_XDISTANCE, 125);
ObjectSet("sig", OBJPROP_YDISTANCE, 450);}
ObjectSetText("sig","Signal= Ranging", 16,"Times New Roman",Gray);

if (signal == "long")
{
ObjectSetText("sig","Signal= Buy", 16,"Times New Roman",Blue);
if (alert&&long_alert)PlaySound("alert.wav");
long_alert=false;
short_alert=true;
}

if (signal == "short")
{
ObjectSetText("sig","Signal= Sell", 16,"Times New Roman",Red);
if (alert&&short_alert)PlaySound("alert.wav");
short_alert=false;
long_alert=true;
}

if (signal == "Ranging"){ObjectSetText("sig","Signal= Ranging", 16,"Times New Roman",Gray);
}


/*
double total = short_pips+long_pips;
if (ObjectFind("tot") == -1 ){
ObjectCreate("tot", OBJ_LABEL, companion, 0, 0);
ObjectSet("tot", OBJPROP_COLOR, Red);
ObjectSet("tot", OBJPROP_XDISTANCE, 10);
ObjectSet("tot", OBJPROP_YDISTANCE, 360);}
ObjectSetText("tot","Total= "+total+"", 16,"Times New Roman",Yellow);

*/
string trail3 =DoubleToStr(start_trail,2);
string trail2 =DoubleToStr(trail,2);
string pcnt2 = DoubleToStr(pcnt,2);
string pcnt3 = DoubleToStr(pcntd,2);
string target3 = DoubleToStr(target_dollars,2);
string target2 = DoubleToStr(starting_target,2);
if (ObjectFind("pc") == -1 ){
ObjectCreate("pc", OBJ_LABEL, companion, 0, 0);
ObjectSet("pc", OBJPROP_COLOR, Red);
ObjectSet("pc", OBJPROP_XDISTANCE, 220);
ObjectSet("pc", OBJPROP_YDISTANCE, 0);}
if (pcnt>0)ObjectSetText("pc","Profit = $"+pcnt3+"     %"+pcnt2+"", profit_font_size,"Times New Roman",SpringGreen);
if (pcnt<0)ObjectSetText("pc","Profit = $"+pcnt3+"     %"+pcnt2+"", profit_font_size,"Times New Roman",Red);
if (pcnt==0)ObjectSetText("pc","Profit = $"+pcnt3+"     %"+pcnt2+"", profit_font_size,"Times New Roman",Yellow);
if (ObjectFind("status") == -1 ){
ObjectCreate("status", OBJ_LABEL, companion, 0, 0);
ObjectSet("status", OBJPROP_COLOR, Red);
ObjectSet("status", OBJPROP_XDISTANCE, 140);
ObjectSet("status", OBJPROP_YDISTANCE, 250);}

ObjectSetText("status","status = "+stat+"", profit_font_size,"Times New Roman",Green);
if (stat!= "waiting")ObjectSet("status", OBJPROP_COLOR, Red);
if (stat== "waiting")ObjectSet("status", OBJPROP_COLOR, Green);

//////////////////////////////////////////////////////////////////////////
if (ObjectFind("open_longs") == -1 )
{
ObjectCreate("open_longs", OBJ_LABEL, companion, 0, 0);
ObjectSet("open_longs", OBJPROP_COLOR, Red);
ObjectSet("open_longs", OBJPROP_XDISTANCE, 140);
ObjectSet("open_longs", OBJPROP_YDISTANCE, 150);
ObjectSetText("open_longs","open longs", 16,"Times New Roman",DeepSkyBlue);}  
        //////////////////////////////////////////////////////////////////////////
        
        //////////////////////////////////////////////////////////////////////////                                                       
if (exit_on_reverse&&signal != "short"&&ObjectGet("open_longs", OBJPROP_XDISTANCE) != 140)
{
ObjectSetText("status","status = opening buys", profit_font_size,"Times New Roman",Red);
longs_allowed=true;
open_buys=true;                      
ObjectSet ("open_longs", OBJPROP_XDISTANCE, 140);
ObjectSet ("open_longs", OBJPROP_YDISTANCE, 150);}
//////////////////////////////////////////////////////////////////////////


if (exit_on_reverse&&signal == "short")ObjectSetText("open_longs","open longs", 16,"Times New Roman",Gray);
if (exit_on_reverse&&signal != "short")ObjectSetText("open_longs","open longs", 16,"Times New Roman",DeepSkyBlue);
if (!exit_on_reverse)ObjectSetText("open_longs","open longs", 16,"Times New Roman",DeepSkyBlue);
//////////////////////////////////////////////////////////////////////////
if (exit_on_reverse==false&&ObjectGet("open_longs", OBJPROP_XDISTANCE) != 140)
{
ObjectSetText("status","status = opening buys", profit_font_size,"Times New Roman",Red);
longs_allowed=true;
open_buys=true;                      
ObjectSet ("open_longs", OBJPROP_XDISTANCE, 140);
ObjectSet ("open_longs", OBJPROP_YDISTANCE, 150);}
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
if (ObjectFind("open_shorts") == -1 )
{
ObjectCreate("open_shorts", OBJ_LABEL, companion, 0, 0);
ObjectSet("open_shorts", OBJPROP_COLOR, Red);
ObjectSet("open_shorts", OBJPROP_XDISTANCE, 140);
ObjectSet("open_shorts", OBJPROP_YDISTANCE, 180);
ObjectSetText("open_shorts","open shorts", 16,"Times New Roman",Orange);}  
       //////////////////////////////////////////////////////////////////////////                                                        
if (exit_on_reverse&&signal != "long"&&ObjectGet("open_shorts", OBJPROP_XDISTANCE) != 140)
{
ObjectSetText("status","status = opening sells", profit_font_size,"Times New Roman",Red);
shorts_allowed=true;
open_sells=true;                          
ObjectSet ("open_shorts", OBJPROP_XDISTANCE, 140);
ObjectSet ("open_shorts", OBJPROP_YDISTANCE, 180);}
//////////////////////////////////////////////////////////////////////////
if (exit_on_reverse&&signal == "long")ObjectSetText("open_shorts","open shorts", 16,"Times New Roman",Gray);
if (exit_on_reverse&&signal != "long")ObjectSetText("open_shorts","open shorts", 16,"Times New Roman",Orange);
if (!exit_on_reverse)ObjectSetText("open_shorts","open shorts", 16,"Times New Roman",Orange);
//////////////////////////////////////////////////////////////////////////
if (!exit_on_reverse&&ObjectGet("open_shorts", OBJPROP_XDISTANCE) != 140)
{
ObjectSetText("status","status = opening sells", profit_font_size,"Times New Roman",Red);
shorts_allowed=true;
open_sells=true;                              
ObjectSet ("open_shorts", OBJPROP_XDISTANCE, 140);
ObjectSet ("open_shorts", OBJPROP_YDISTANCE, 180);}
//////////////////////////////////////////////////////////////////////////
if (ObjectFind("close") == -1 )
{
ObjectCreate("close", OBJ_LABEL, companion, 0, 0);
ObjectSet("close", OBJPROP_COLOR, Red);
ObjectSet("close", OBJPROP_XDISTANCE, 290);
ObjectSet("close", OBJPROP_YDISTANCE, 115);
ObjectSetText("close","close all", 16,"Times New Roman",Red);}                                                                 
if (ObjectGet("close", OBJPROP_XDISTANCE) != 290)
{
ObjectSetText("status","status = closing all trades", profit_font_size,"Times New Roman",Red);
close_all=true;                                                       
ObjectSet ("close", OBJPROP_XDISTANCE, 290);
ObjectSet ("close", OBJPROP_YDISTANCE, 115);}

if (ObjectFind("close2") == -1 )
{
ObjectCreate("close2", OBJ_LABEL, companion, 0, 0);
ObjectSet("close2", OBJPROP_COLOR, Red);
ObjectSet("close2", OBJPROP_XDISTANCE, 430);
ObjectSet("close2", OBJPROP_YDISTANCE, 115);
ObjectSetText("close2","close half", 16,"Times New Roman",Red);}                                                                 
if (ObjectGet("close2", OBJPROP_XDISTANCE) != 430)
{
close_half();                                                       
ObjectSet ("close2", OBJPROP_XDISTANCE, 430);
ObjectSet ("close2", OBJPROP_YDISTANCE, 115);}


if (ObjectFind("brkev") == -1 )
{
ObjectCreate("brkev", OBJ_LABEL, companion, 0, 0);
ObjectSet("brkev", OBJPROP_COLOR, Red);
ObjectSet("brkev", OBJPROP_XDISTANCE, 430);
ObjectSet("brkev", OBJPROP_YDISTANCE, 150);
ObjectSetText("brkev","break even", 16,"Times New Roman",Yellow);}                                                                 
if (ObjectGet("brkev", OBJPROP_XDISTANCE) != 430)
{
breakeven();                                                       
ObjectSet ("brkev", OBJPROP_XDISTANCE, 430);
ObjectSet ("brkev", OBJPROP_YDISTANCE, 150);}

if (ObjectFind("brkev2") == -1 )
{
ObjectCreate("brkev2", OBJ_LABEL, companion, 0, 0);
ObjectSet("brkev2", OBJPROP_COLOR, Red);
ObjectSet("brkev2", OBJPROP_XDISTANCE, 430);
ObjectSet("brkev2", OBJPROP_YDISTANCE, 180);
ObjectSetText("brkev2","remove stop loss", 16,"Times New Roman",Yellow);}                                                                 
if (ObjectGet("brkev2", OBJPROP_XDISTANCE) != 430)
{
removesl();                                                       
ObjectSet ("brkev2", OBJPROP_XDISTANCE, 430);
ObjectSet ("brkev2", OBJPROP_YDISTANCE, 180);}

if (ObjectFind("closel") == -1 )
{
ObjectCreate("closel", OBJ_LABEL, companion, 0, 0);
ObjectSet("closel", OBJPROP_COLOR, Red);
ObjectSet("closel", OBJPROP_XDISTANCE, 290);
ObjectSet("closel", OBJPROP_YDISTANCE, 150);
ObjectSetText("closel","close longs", 16,"Times New Roman",DeepSkyBlue);}                                                                 
if (ObjectGet("closel", OBJPROP_XDISTANCE) != 290)
{
ObjectSetText("status","status = closing buys", profit_font_size,"Times New Roman",Red);
close_l=true;                                                       
ObjectSet ("closel", OBJPROP_XDISTANCE, 290);
ObjectSet ("closel", OBJPROP_YDISTANCE, 150);}

if (ObjectFind("closes") == -1 )
{
ObjectCreate("closes", OBJ_LABEL, companion, 0, 0);
ObjectSet("closes", OBJPROP_COLOR, Red);
ObjectSet("closes", OBJPROP_XDISTANCE, 290);
ObjectSet("closes", OBJPROP_YDISTANCE, 180);
ObjectSetText("closes","close shorts", 16,"Times New Roman",Orange);}                                                                 
if (ObjectGet("closes", OBJPROP_XDISTANCE) != 290)
{
ObjectSetText("status","status = closing sells", profit_font_size,"Times New Roman",Red);
close_s=true;                                                       
ObjectSet ("closes", OBJPROP_XDISTANCE, 290);
ObjectSet ("closes", OBJPROP_YDISTANCE, 180);}

if (ObjectFind("etrail") == -1 )
{
ObjectCreate("etrail", OBJ_LABEL, companion, 0, 0);
ObjectSet("etrail", OBJPROP_COLOR, Red);
ObjectSet("etrail", OBJPROP_XDISTANCE, 140);
ObjectSet("etrail", OBJPROP_YDISTANCE, 40);
ObjectSetText("etrail","equity trail", 16,"Times New Roman",Gray);}   
                                                              
if (equity_trail==false&&ObjectGet("etrail", OBJPROP_XDISTANCE) != 140)
{
equity_trail=true;                                                      
ObjectSet ("etrail", OBJPROP_XDISTANCE, 140);
ObjectSet ("etrail", OBJPROP_YDISTANCE, 40);
}

if (equity_trail&&ObjectGet("etrail", OBJPROP_XDISTANCE) != 140)
{
equity_trail=false;                                                      
ObjectSet ("etrail", OBJPROP_XDISTANCE, 140);
ObjectSet ("etrail", OBJPROP_YDISTANCE, 40);
}
if (equity_trail==false)ObjectSetText("etrail","equity trail= Disabled ", 16,"Times New Roman",Gray);
if (equity_trail)ObjectSetText("etrail","equity trail=  "+trail2+"     start trailing at=  "+trail3+"", 16,"Times New Roman",White);

if (ObjectFind("lock") == -1 )
{
ObjectCreate("lock", OBJ_LABEL, companion, 0, 0);
ObjectSet("lock", OBJPROP_COLOR, Red);
ObjectSet("lock", OBJPROP_XDISTANCE, 480);
ObjectSet("lock", OBJPROP_YDISTANCE, 20);
ObjectSetText("lock","lock profit now", 16,"Times New Roman",Orange);}                                                                 
if (ObjectGet("lock", OBJPROP_XDISTANCE) != 480)
{


//if (pcnt/2>target)target= pcnt/2; 
  if (pcnt-trail>0&&starting_target<pcnt-trail )starting_target=pcnt-trail;                                                   
ObjectSet ("lock", OBJPROP_XDISTANCE, 480);
ObjectSet ("lock", OBJPROP_YDISTANCE, 20);}
string short_pips2=DoubleToStr(short_pips,0);
string long_pips2=DoubleToStr(long_pips,0);
string highest_short_pips2=DoubleToStr(highest_short_pips,0);
string highest_long_pips2=DoubleToStr(highest_long_pips,0);


if (ObjectFind("s_pips") == -1 ){
ObjectCreate("s_pips", OBJ_LABEL, companion, 0, 0);
ObjectSet("s_pips", OBJPROP_COLOR, Red);
ObjectSet("s_pips", OBJPROP_XDISTANCE, 9);
ObjectSet("s_pips", OBJPROP_YDISTANCE, 360);}
ObjectSetText("s_pips","short pips "+short_pips2+"", 16,"Times New Roman",Orange);

if (ObjectFind("l_pips") == -1 ){
ObjectCreate("l_pips", OBJ_LABEL, companion, 0, 0);
ObjectSet("l_pips", OBJPROP_COLOR, Red);
ObjectSet("l_pips", OBJPROP_XDISTANCE, 9);
ObjectSet("l_pips", OBJPROP_YDISTANCE, 390);}
ObjectSetText("l_pips","long pips "+long_pips2+"", 16,"Times New Roman",DeepSkyBlue);


if (ObjectFind("rese") == -1 ){
ObjectCreate("rese", OBJ_LABEL, companion, 0, 0);
ObjectSet("rese", OBJPROP_COLOR, Red);
ObjectSet("rese", OBJPROP_XDISTANCE, 10);
ObjectSet("rese", OBJPROP_YDISTANCE, 420);}
if (reset_ea_zero_pips)ObjectSetText("rese","ea will reset if both pips get negative", 12,"Times New Roman",White);
if (reset_ea_zero_pips==false)ObjectSetText("rese","ea will not reset until reversal", 12,"Times New Roman",Gray);

if (ObjectFind("s_pips2") == -1 ){
ObjectCreate("s_pips2", OBJ_LABEL, companion, 0, 0);
ObjectSet("s_pips2", OBJPROP_COLOR, Red);
ObjectSet("s_pips2", OBJPROP_XDISTANCE, 250);
ObjectSet("s_pips2", OBJPROP_YDISTANCE, 360);}
ObjectSetText("s_pips2","highest "+highest_short_pips2+"", 16,"Times New Roman",Orange);

if (ObjectFind("l_pips2") == -1 ){
ObjectCreate("l_pips2", OBJ_LABEL, companion, 0, 0);
ObjectSet("l_pips2", OBJPROP_COLOR, Red);
ObjectSet("l_pips2", OBJPROP_XDISTANCE, 250);
ObjectSet("l_pips2", OBJPROP_YDISTANCE, 390);}
ObjectSetText("l_pips2","highest "+highest_long_pips2+"", 16,"Times New Roman",DeepSkyBlue);


if (time_restriction &&ObjectFind("tyme") != -1 ){
ObjectDelete("tyme");}



if (ObjectFind("exonr") == -1 ){
ObjectCreate("exonr", OBJ_LABEL, companion, 0, 0);
ObjectSet("exonr", OBJPROP_COLOR, Red);
ObjectSet("exonr", OBJPROP_XDISTANCE, 140);
ObjectSet("exonr", OBJPROP_YDISTANCE, 280);}
if (exit_on_reverse)ObjectSetText("exonr","exit on reverse enabled", 16,"Times New Roman",White);
if (!exit_on_reverse)ObjectSetText("exonr","exit on reverse disabled", 16,"Times New Roman",Gray);

if (time_restriction==false&&ObjectFind("tyme") == -1 ){
ObjectCreate("tyme", OBJ_LABEL, companion, 0, 0);
ObjectSet("tyme", OBJPROP_COLOR, Red);
ObjectSet("tyme", OBJPROP_XDISTANCE, 320);
ObjectSet("tyme", OBJPROP_YDISTANCE, 250);
ObjectSetText("tyme","non trading hours", 32,"Times New Roman",Orange);}

if (ObjectFind("trgt") == -1 ){
ObjectCreate("trgt", OBJ_LABEL, companion, 0, 0);
ObjectSet("trgt", OBJPROP_COLOR, Red);
ObjectSet("trgt", OBJPROP_XDISTANCE, 140);
ObjectSet("trgt", OBJPROP_YDISTANCE, 20);}
ObjectSetText("trgt","equity stop loss = $"+target3+"     %"+target2+"", 16,"Times New Roman",White);
}
//+------------------------------------------------------------------+
//|     TC                                
//+------------------------------------------------------------------+
void close()
{
ObjectSetText("status","status = closing all trades", profit_font_size,"Times New Roman",Red);
open_buys=false;open_sells=false;
int totalorders = OrdersTotal();
for(int i=totalorders-1;i>=0;i--)
{
OrderSelect(i, SELECT_BY_POS);
{

if (OrderType() == OP_BUY ) 
{OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), slippage, Blue );
shorts_allowed=true;

}  
        
if (OrderType() == OP_SELL ) 
{OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), slippage, Red );
longs_allowed=true;
}

}
}
return;
}
//+------------------------------------------------------------------+
//|     TC                                
//+------------------------------------------------------------------+
void close_half()
{
ObjectSetText("status","status = closing half lots", profit_font_size,"Times New Roman",Red);
int totalorders = OrdersTotal();
for(int i=totalorders-1;i>=0;i--)
{
OrderSelect(i, SELECT_BY_POS);
{

if ( OrderType() == OP_BUY ) {
OrderClose( OrderTicket(), OrderLots()/2, MarketInfo(OrderSymbol(), MODE_BID), slippage, Blue );}
           
if ( OrderType() == OP_SELL ) {
OrderClose( OrderTicket(), OrderLots()/2, MarketInfo(OrderSymbol(), MODE_ASK), slippage, Red );}

}
}
return;
}
//+------------------------------------------------------------------+
//|     TC                                
//+------------------------------------------------------------------+
void close_longs()
{
shorts_allowed=true;
ObjectSetText("status","status = closing buys", profit_font_size,"Times New Roman",Red);
open_buys=false;open_sells=false;
int totalorders = OrdersTotal();
for(int i=totalorders-1;i>=0;i--)
{
OrderSelect(i, SELECT_BY_POS);
{
if (OrderType() == OP_BUY ) 
OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), slippage, Blue );  

}
}
return;
}
//+------------------------------------------------------------------+
//|     TC                                
//+------------------------------------------------------------------+
void close_shorts()
{
longs_allowed=true;
ObjectSetText("status","status = closing sells", profit_font_size,"Times New Roman",Red);
open_buys=false;open_sells=false;
int totalorders = OrdersTotal();
for(int i=totalorders-1;i>=0;i--)
{
OrderSelect(i, SELECT_BY_POS);
{
if (OrderType() == OP_SELL )
OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), slippage, Red ); 


}
}
return;
}


//+------------------------------------------------------------------+
//|     TC                                
//+------------------------------------------------------------------+
void breakeven()
{
ObjectSetText("status","status = setting breakeven", profit_font_size,"Times New Roman",Red);
int totalorders = OrdersTotal();
for(int i=totalorders-1;i>=0;i--)
{
OrderSelect(i, SELECT_BY_POS);
{
if ( OrderType() == OP_BUY ) {
OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Green);
 
}          
if ( OrderType() == OP_SELL ) {
OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Green);
 
}
}
}
return;
}


//+------------------------------------------------------------------+
//|     TC                                
//+------------------------------------------------------------------+
void removesl()
{
ObjectSetText("status","status = removing stop loss", profit_font_size,"Times New Roman",Red);
int totalorders = OrdersTotal();
for(int i=totalorders-1;i>=0;i--)
{
OrderSelect(i, SELECT_BY_POS);
{
if ( OrderType() == OP_BUY ) {
OrderModify(OrderTicket(),OrderOpenPrice(),0,OrderTakeProfit(),0,Green);
 
}          
if ( OrderType() == OP_SELL ) {
OrderModify(OrderTicket(),OrderOpenPrice(),0,OrderTakeProfit(),0,Green);
 
}
}
}
return;
}

void GetCorrectPairs()
{
   if (BrokerIsIBFX)
   {
     long_basket1 = GetCorrectSymbol(ilong_basket1);
     long_basket2 = GetCorrectSymbol(ilong_basket2);
     long_basket3 = GetCorrectSymbol(ilong_basket3);
     long_basket4 = GetCorrectSymbol(ilong_basket4);
     long_basket5 = GetCorrectSymbol(ilong_basket5);
     long_basket6 = GetCorrectSymbol(ilong_basket6);
     long_basket7 = GetCorrectSymbol(ilong_basket7);
   
     short_basket1 = GetCorrectSymbol(ishort_basket1);
     short_basket2 = GetCorrectSymbol(ishort_basket2);
     short_basket3 = GetCorrectSymbol(ishort_basket3);
     short_basket4 = GetCorrectSymbol(ishort_basket4);
     short_basket5 = GetCorrectSymbol(ishort_basket5);
     short_basket6 = GetCorrectSymbol(ishort_basket6);
     short_basket7 = GetCorrectSymbol(ishort_basket7);
     
     price1 = iprice1;
     price2 = iprice2;
     price3 = iprice3;
     price4 = iprice4;
     price5 = iprice5;
     price6 = iprice6;
     price7 = iprice7;
     price8 = iprice8;
     price9 = iprice9;
     price10 = iprice10;
     price11 = iprice11;
     price12 = iprice12;
     price13 = iprice13;
     price14 = iprice14;
   }
   else
   {
     long_basket1 = GetCorrectSymbol(flong_basket1);
     long_basket2 = GetCorrectSymbol(flong_basket2);
     long_basket3 = GetCorrectSymbol(flong_basket3);
     long_basket4 = GetCorrectSymbol(flong_basket4);
     long_basket5 = GetCorrectSymbol(flong_basket5);
     long_basket6 = GetCorrectSymbol(flong_basket6);
     long_basket7 = GetCorrectSymbol(flong_basket7);
   
     short_basket1 = GetCorrectSymbol(fshort_basket1);
     short_basket2 = GetCorrectSymbol(fshort_basket2);
     short_basket3 = GetCorrectSymbol(fshort_basket3);
     short_basket4 = GetCorrectSymbol(fshort_basket4);
     short_basket5 = GetCorrectSymbol(fshort_basket5);
     short_basket6 = GetCorrectSymbol(fshort_basket6);
     short_basket7 = GetCorrectSymbol(fshort_basket7);

     price1 = fprice1;
     price2 = fprice2;
     price3 = fprice3;
     price4 = fprice4;
     price5 = fprice5;
     price6 = fprice6;
     price7 = fprice7;
     price8 = fprice8;
     price9 = fprice9;
     price10 = fprice10;
     price11 = fprice11;
     price12 = fprice12;
     price13 = fprice13;
     price14 = fprice14;
   }
}

string GetCorrectSymbol(string pair)
{
   string AddChar, myPair;
   
   myPair = pair;
   if (StringLen(pair) > 0)
   {
   if (StringLen(Symbol()) == 7)
     {
      AddChar = StringSubstr(Symbol(), 6, 1);
      myPair = pair + AddChar;
     }
   }
   return(myPair);
   
}

double dPoint(string sym)
{
  double _Point = MarketInfo(sym, MODE_POINT);
  if (StringFind(sym, "JPY")>=0)
      _Point=0.01;
  
  if (_Point==0) _Point=0.0001; 
  
  return (_Point);
}

void GetSpreads()
{
    spread1=MarketInfo(long_basket1,MODE_SPREAD);
    spread2=MarketInfo(long_basket2,MODE_SPREAD);
    spread3=MarketInfo(long_basket3,MODE_SPREAD);
    spread4=MarketInfo(long_basket4,MODE_SPREAD);
    spread5=MarketInfo(long_basket5,MODE_SPREAD);
    spread6=MarketInfo(long_basket6,MODE_SPREAD);
    spread7=MarketInfo(long_basket7,MODE_SPREAD);
    spread8=MarketInfo(short_basket1,MODE_SPREAD);
    spread9=MarketInfo(short_basket2,MODE_SPREAD);
    spread10=MarketInfo(short_basket3,MODE_SPREAD);
    spread11=MarketInfo(short_basket4,MODE_SPREAD);
    spread12=MarketInfo(short_basket5,MODE_SPREAD);
    spread13=MarketInfo(short_basket6,MODE_SPREAD);
    spread14=MarketInfo(short_basket7,MODE_SPREAD);
}

bool CheckTradeFilters()
{
   bool myStop;
   
   myStop = false;
   
   if (UseTradingHours)
   {
     myStop = CheckTradingTimes();
   }

   
//+------------------------------------------------------------------+
//| Friday No trade zone                                             |
//+------------------------------------------------------------------+
   if (myStop == false)
   {
      if (UseFridayNoTradeTime)
      {
         if(DayOfWeek()==5 && Hour() >= FridayFinalHour)
         {
            myStop = true;
         }
      }
   }
   
   return(myStop);
}

bool IsNotValidTradingTime( int StartHour, int EndHour)
{
  int lHour=Hour() *100+Minute( );
  if(StartHour<=EndHour)
  {
    if(lHour<StartHour || lHour>EndHour) return(true) ;
  }
  else if(lHour>EndHour && lHour<StartHour) return(true) ;
  return(false) ;
}

bool CheckTradingTimes()
{
   bool StopTrading;
   int ct;
   ct = Hour() * 100 + Minute();
   
     StopTrading = true;
// Check trading Asian Market
     if (TradeAsianMarket)
     {
        StopTrading = IsNotValidTradingTime(AsianStart, AsianStop);
     }
     if (StopTrading == true)
     {
// Check trading European Market
       if (TradeEuropeanMarket)
       {
         StopTrading = IsNotValidTradingTime(EurStart, EurStop);
       }
     }
     if (StopTrading == true)
     {
// Check trading New York Market
       if (TradeNewYorkMarket)
       {
         StopTrading = IsNotValidTradingTime(NYStart, NYStop);
       }
     }
     
     return(StopTrading);
}


